package com.yizhi.application.service;

import com.baomidou.mybatisplus.service.IService;
import com.yizhi.application.domain.Enroll;
import com.yizhi.enroll.application.vo.GetEnrollVO;
import com.yizhi.enroll.application.vo.ProjectAccountVO;
import com.yizhi.enroll.application.vo.ReturnEnrollVO;

/**
 * <p>
 * 报名主体表，入口在培训项目 服务类
 * </p>
 *
 * @author bob123
 * @since 2018-03-07
 */
public interface EnrollService extends IService<Enroll> {

	/**
	 * 新增
	 * @param trEnroll
	 * @return
	 */
	Long insertEnroll(Enroll enroll);

	/**
	 * 修改
	 * @param trEnroll
	 * @return
	 */
	Long updateEnroll(Enroll trEnroll);

	/**
	 * 通过项目ID获取项目下学员是否需要审核 
	 * @param trainingProjectId
	 * @return
	 */
	Integer queryNeedAuditByTrainingProjectId(Long trainingProjectId);
	
	/**
	 * 通过项目ID获取 报名信息
	 * @param trainingProjectId
	 * @return
	 */
	Enroll selectByProjectId(Long trainingProjectId);
	
	/**
	 * 培训项目id， 学员id 查找 报名信息，是否报名
	 * @param vo
	 * @return
	 */
	ReturnEnrollVO selectEnrollByProjectId(ProjectAccountVO vo);
	
	/**培训项目 id， 学员 id 查找是否审核，报名开始结束时间
	 * @param projectId
	 * @return
	 */
	GetEnrollVO getEnrollByProjectId(Long projectId, Long accountId);

	/**
	 * 根据项目id删除对应的报名配置；
	 * @param vo 项目id
	 * @return 成功返回1；否则返回-1
	 */
	Integer deleteEnrollByProjectId(ProjectAccountVO vo);
}
